/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelTransport } from '../model';
// @ts-ignore
import { PagedModelEntityModelTransport } from '../model';
// @ts-ignore
import { TransportRequestBody } from '../model';
/**
 * TransportEntityControllerApi - axios parameter creator
 * @export
 */
export const TransportEntityControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * delete-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceTransportDelete: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteItemResourceTransportDelete', 'id', id)
            const localVarPath = `/transports/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-transport
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceTransportGet1: async (page?: number, size?: number, sort?: Array<string>, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/transports`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceTransportGet: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getItemResourceTransportGet', 'id', id)
            const localVarPath = `/transports/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * patch-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceTransportPatch: async (id: string, transportRequestBody: TransportRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('patchItemResourceTransportPatch', 'id', id)
            // verify required parameter 'transportRequestBody' is not null or undefined
            assertParamExists('patchItemResourceTransportPatch', 'transportRequestBody', transportRequestBody)
            const localVarPath = `/transports/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * create-transport
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceTransportPost: async (transportRequestBody: TransportRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'transportRequestBody' is not null or undefined
            assertParamExists('postCollectionResourceTransportPost', 'transportRequestBody', transportRequestBody)
            const localVarPath = `/transports`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * update-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceTransportPut: async (id: string, transportRequestBody: TransportRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('putItemResourceTransportPut', 'id', id)
            // verify required parameter 'transportRequestBody' is not null or undefined
            assertParamExists('putItemResourceTransportPut', 'transportRequestBody', transportRequestBody)
            const localVarPath = `/transports/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transportRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TransportEntityControllerApi - functional programming interface
 * @export
 */
export const TransportEntityControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TransportEntityControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * delete-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteItemResourceTransportDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteItemResourceTransportDelete(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-transport
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCollectionResourceTransportGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PagedModelEntityModelTransport>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCollectionResourceTransportGet1(page, size, sort, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getItemResourceTransportGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransport>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getItemResourceTransportGet(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * patch-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async patchItemResourceTransportPatch(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransport>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.patchItemResourceTransportPatch(id, transportRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * create-transport
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postCollectionResourceTransportPost(transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransport>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postCollectionResourceTransportPost(transportRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * update-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async putItemResourceTransportPut(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelTransport>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.putItemResourceTransportPut(id, transportRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TransportEntityControllerApi - factory interface
 * @export
 */
export const TransportEntityControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TransportEntityControllerApiFp(configuration)
    return {
        /**
         * delete-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceTransportDelete(id: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteItemResourceTransportDelete(id, options).then((request) => request(axios, basePath));
        },
        /**
         * get-transport
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceTransportGet1(page?: number, size?: number, sort?: Array<string>, options?: any): AxiosPromise<PagedModelEntityModelTransport> {
            return localVarFp.getCollectionResourceTransportGet1(page, size, sort, options).then((request) => request(axios, basePath));
        },
        /**
         * get-transport
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceTransportGet(id: string, options?: any): AxiosPromise<EntityModelTransport> {
            return localVarFp.getItemResourceTransportGet(id, options).then((request) => request(axios, basePath));
        },
        /**
         * patch-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceTransportPatch(id: string, transportRequestBody: TransportRequestBody, options?: any): AxiosPromise<EntityModelTransport> {
            return localVarFp.patchItemResourceTransportPatch(id, transportRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * create-transport
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceTransportPost(transportRequestBody: TransportRequestBody, options?: any): AxiosPromise<EntityModelTransport> {
            return localVarFp.postCollectionResourceTransportPost(transportRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * update-transport
         * @param {string} id 
         * @param {TransportRequestBody} transportRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceTransportPut(id: string, transportRequestBody: TransportRequestBody, options?: any): AxiosPromise<EntityModelTransport> {
            return localVarFp.putItemResourceTransportPut(id, transportRequestBody, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TransportEntityControllerApi - interface
 * @export
 * @interface TransportEntityControllerApi
 */
export interface TransportEntityControllerApiInterface {
    /**
     * delete-transport
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    deleteItemResourceTransportDelete(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;

    /**
     * get-transport
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    getCollectionResourceTransportGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): AxiosPromise<PagedModelEntityModelTransport>;

    /**
     * get-transport
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    getItemResourceTransportGet(id: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransport>;

    /**
     * patch-transport
     * @param {string} id 
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    patchItemResourceTransportPatch(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransport>;

    /**
     * create-transport
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    postCollectionResourceTransportPost(transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransport>;

    /**
     * update-transport
     * @param {string} id 
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApiInterface
     */
    putItemResourceTransportPut(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelTransport>;

}

/**
 * TransportEntityControllerApi - object-oriented interface
 * @export
 * @class TransportEntityControllerApi
 * @extends {BaseAPI}
 */
export class TransportEntityControllerApi extends BaseAPI implements TransportEntityControllerApiInterface {
    /**
     * delete-transport
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public deleteItemResourceTransportDelete(id: string, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).deleteItemResourceTransportDelete(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-transport
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public getCollectionResourceTransportGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).getCollectionResourceTransportGet1(page, size, sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-transport
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public getItemResourceTransportGet(id: string, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).getItemResourceTransportGet(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * patch-transport
     * @param {string} id 
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public patchItemResourceTransportPatch(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).patchItemResourceTransportPatch(id, transportRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * create-transport
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public postCollectionResourceTransportPost(transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).postCollectionResourceTransportPost(transportRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * update-transport
     * @param {string} id 
     * @param {TransportRequestBody} transportRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransportEntityControllerApi
     */
    public putItemResourceTransportPut(id: string, transportRequestBody: TransportRequestBody, options?: AxiosRequestConfig) {
        return TransportEntityControllerApiFp(this.configuration).putItemResourceTransportPut(id, transportRequestBody, options).then((request) => request(this.axios, this.basePath));
    }
}
